Attribute VB_Name = "Public_Delarations"
Option Explicit

'****************** USB INTERFACE DECLARATIONS ********************
'FUNCTION CALLs TO FTD2XX DRIVER S.W.
Public Declare Function FT_Open Lib "FTD2XX.DLL" (ByVal intDeviceNumber As Integer, ByRef USBHandle As Long) As Long
Public Declare Function FT_Close Lib "FTD2XX.DLL" (ByVal USBHandle As Long) As Long
Public Declare Function FT_Read Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByVal lpszBuffer As String, ByVal lngBufferSize As Long, ByRef lngBytesReturned As Long) As Long
Public Declare Function FT_Write Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByVal lpszBuffer As String, ByVal lngBufferSize As Long, ByRef NumberBytesWrittenToUSB As Long) As Long
Public Declare Function FT_SetBaudRate Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByVal lngBaudRate As Long) As Long
Public Declare Function FT_SetDataCharacteristics Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByVal byWordLength As Byte, ByVal byStopBits As Byte, ByVal byParity As Byte) As Long
Public Declare Function FT_SetFlowControl Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByVal intFlowControl As Integer, ByVal byXonChar As Byte, ByVal byXoffChar As Byte) As Long
Public Declare Function FT_ResetDevice Lib "FTD2XX.DLL" (ByVal USBHandle As Long) As Long
Public Declare Function FT_SetDtr Lib "FTD2XX.DLL" (ByVal USBHandle As Long) As Long
Public Declare Function FT_ClrDtr Lib "FTD2XX.DLL" (ByVal USBHandle As Long) As Long
Public Declare Function FT_SetRts Lib "FTD2XX.DLL" (ByVal USBHandle As Long) As Long
Public Declare Function FT_ClrRts Lib "FTD2XX.DLL" (ByVal USBHandle As Long) As Long
Public Declare Function FT_GetModemStatus Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByRef lngModemStatus As Long) As Long
Public Declare Function FT_Purge Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByVal lngMask As Long) As Long
Public Declare Function FT_GetStatus Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByRef lngRxBytes As Long, ByRef lngTxBytes As Long, ByRef lngEventsDWord As Long) As Long
Public Declare Function FT_GetQueueStatus Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByRef lngRxBytes As Long) As Long
Public Declare Function FT_GetEventStatus Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByRef lngEventsDWord As Long) As Long
Public Declare Function FT_SetChars Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByVal byEventChar As Byte, ByVal byEventCharEnabled As Byte, ByVal byErrorChar As Byte, ByVal byErrorCharEnabled As Byte) As Long
Public Declare Function FT_SetTimeouts Lib "FTD2XX.DLL" (ByVal USBHandle As Long, ByVal lngReadTimeout As Long, ByVal lngWriteTimeout As Long) As Long
Public Declare Function FT_SetBreakOn Lib "FTD2XX.DLL" (ByVal USBHandle As Long) As Long
Public Declare Function FT_SetBreakOff Lib "FTD2XX.DLL" (ByVal USBHandle As Long) As Long


'********** USB INTERFACE CONSTANTS & VARIABLES ******************
' Return codes
Public Const FT_OK = 0
Public Const FT_INVALID_HANDLE = 1
Public Const FT_DEVICE_NOT_FOUND = 2
Public Const FT_DEVICE_NOT_OPENED = 3
Public Const FT_IO_ERROR = 4
Public Const FT_INSUFFICIENT_RESOURCES = 5


' Word Lengths
Public Const FT_BITS_8 = 8
Public Const FT_BITS_7 = 7

' Stop Bits
Public Const FT_STOP_BITS_1 = 0
Public Const FT_STOP_BITS_1_5 = 1
Public Const FT_STOP_BITS_2 = 2

' Parity
Public Const FT_PARITY_NONE = 0
Public Const FT_PARITY_ODD = 1
Public Const FT_PARITY_EVEN = 2
Public Const FT_PARITY_MARK = 3
Public Const FT_PARITY_SPACE = 4

' Flow Control
Public Const FT_FLOW_NONE = &H0
Public Const FT_FLOW_RTS_CTS = &H100
Public Const FT_FLOW_DTR_DSR = &H200
Public Const FT_FLOW_XON_XOFF = &H400

' Purge rx and tx buffers
Public Const FT_PURGE_RX = 1
Public Const FT_PURGE_TX = 2



Public USBHandle As Long                 'The USB device's ID

Public USB_Output_buffer As String       'To USB PORT from Application
Public USB_TXD_Buffer As String * 256    'Holds bytes during transmission to USB

Public NumberBytesWrittenToUSB As Long   'Number of bytes that have been written, used by ftWrite
Public NumberOfBytesToWrite As Long      'Holds the number bytes to write to the USB device

Public USB_Input_buffer As String        'From USB PORT to Application
Public USB_RXD_buffer As String * 256    'Used to hold bytes when received from USB
Public TotalBytesToBeRead As Long        'Number of bytes to be read, used by ftRead

Public TotalBytesReturned As Long        'Number of bytes that have been received by ftRead

Public NumberBytesInBuffer As Long       'Holds the number of bytes accumulated in the USB_Input_buffer



Public flFailed As Boolean
Public flTimedout As Boolean
Public flFatalError As Boolean
Public ftStatus As Long

Public CBaud As Integer 'Current Baud 0=19200 1=9600 2=4800 3=1200
Public CParity As Integer 'Current Parity 1=Odd 2=Even 3=Mark 4=Space
Public CDataBits As Integer 'Current DataBits 7=7 8=8
Public CStopBits As Integer 'Current Stop Bits 0=1 1=1.5 2 =2
Public CFlow As Integer 'Current 0=None 1=Xon/Xoff 2=RTS/CTS 3=DTR/DSR
Public CTimeout As Long 'Current time out in mS

Public CRQue As Long 'Current number of bytes in rec que
Public CTQue As Long 'Current number of bytes in transmit que
Public CEvent As Long 'Current event status
Public CModem As Long 'Current modem status
Public USB_ComStat As String 'Holds the Communication status of last usb command sent
'









Public Sub USB_OpenStat()



If FT_Close(USBHandle) <> FT_OK Then
        USB_ComStat = "Close Failed"
 End If
'--------- Open device ---------------
If FT_Open(0, USBHandle) <> FT_OK Then
        USB_ComStat = "Open Failed"
        GoTo Error_Endsub
       Else
        USB_ComStat = "Open OK"
 End If

'--------- Set Baud -----------------
  
If FT_SetBaudRate(USBHandle, 9600) <> FT_OK Then
        USB_ComStat = "SetBaudRate Failed"
        GoTo Error_Endsub
 End If


'----------- Set Data Char ----------
' 7 data bits, bit8 =0, 2 stop bit, no parity

If FT_SetDataCharacteristics(USBHandle, 7, 2, 4) <> FT_OK Then
       USB_ComStat = "SetDataCharacteristics Failed"
       GoTo Error_Endsub
End If
'------------ Set flow --------------
' no flow control

If FT_SetFlowControl(USBHandle, 0, 0, 0) <> FT_OK Then
    USB_ComStat = "SetFlowControl Failed"
    GoTo Error_Endsub
End If

'----------  Set timeout -------------
' 1 second read timeout

If FT_SetTimeouts(USBHandle, 1000, 0) <> FT_OK Then
    USB_ComStat = "SetTimeout Failed"
    GoTo Error_Endsub
End If


USB_ComStat = "Open OK"
Error_Endsub:
End Sub
